<template>
  <component
    :is="tag"
    class="flex gap-2 align-baseline transition-colors"
    :class="{
      'font-bold': hasError || isRunning,
      'text-violet-700': isRunning,
      'text-gray-500': isCancelled || isPending || isSkipped,
      'text-gray-800': hasInvalidStatus || isDone,
      'text-red-700': hasError,
    }"
  >
    <div
      class="w-5 shrink-0 select-none justify-center [&_svg]:size-[1em]"
      aria-hidden="true"
    >
      <div v-if="isDone">✓</div>
      <div v-else-if="isCancelled || hasError">✗</div>
      <svg
        v-else-if="isSkipped"
        class="mt-2"
        viewBox="0 0 24 24"
        stroke="currentColor"
        stroke-width="2"
        fill="none"
      >
        <path d="M12.5,1 Q7,11 12,20 m-5.5,-3 l5,3 l3,-5.5" />
      </svg>
      <svg v-else viewBox="0 0 24 24" class="mt-2" fill="currentColor">
        <circle
          cx="4"
          cy="18"
          r="2"
          :class="{
            'animate-bounce-smooth': isRunning,
          }"
        />
        <circle
          cx="12"
          cy="18"
          r="2"
          class="[animation-delay:150ms]"
          :class="{
            'animate-bounce-smooth': isRunning,
          }"
        />
        <circle
          cx="20"
          cy="18"
          r="2"
          class="[animation-delay:300ms]"
          :class="{
            'animate-bounce-smooth': isRunning,
          }"
        />
      </svg>
    </div>
    <span>{{ label }}</span>
  </component>
</template>

<script lang="ts" setup>
import { computed, PropType } from 'vue'
import { LoadingStepStatus } from '../../enums'

defineOptions({
  name: 'UiLoadingStep',
})

const props = defineProps({
  tag: {
    type: String,
    default: 'li',
  },
  label: {
    type: String,
    default: undefined,
  },
  status: {
    type: Number as PropType<LoadingStepStatus>,
    default: undefined,
  },
})

const hasInvalidStatus = computed(
  () =>
    props.status === undefined || LoadingStepStatus[props.status] === undefined,
)
const hasError = computed(() => props.status === LoadingStepStatus.Error)
const isCancelled = computed(() => props.status === LoadingStepStatus.Cancelled)
const isDone = computed(() => props.status === LoadingStepStatus.Done)
const isPending = computed(() => props.status === LoadingStepStatus.Pending)
const isRunning = computed(() => props.status === LoadingStepStatus.Running)
const isSkipped = computed(() => props.status === LoadingStepStatus.Skipped)
</script>
